<template>
    <div id="vmap" style="width:100%;height:400px"></div>
</template>

<script>
export default {
    data() {
        return {
            data: {},
            tagged: {}
        }
    },
    mounted() {
        this.load();
    },
    methods: {
        load() {
            axios.get('/api/maps')
                .then( (response) => {
                    Object.values(response.data).forEach( val => {
                        this.data[val.path] = {
                            kompetensipedagogic: val.kompetensipedagogic,
                            kompetensikepribadian: val.kompetensikepribadian,
                            kompetensisosial: val.kompetensisosial,
                            kompetensiprofesional: val.kompetensiprofesional,
                            kompetensimethodology: val.kompetensimethodology,
                            kompetensiit: val.kompetensiit,
                            kompetensiimpactandinfluence: val.kompetensiimpactandinfluence,
                            kompetensiachievementorientation: val.kompetensiachievementorientation,
                            kompetensinasionalism: val.kompetensinasionalism,
                            kompetensidevelopingothers: val.kompetensidevelopingothers,
                        }

                        this.tagged[val.path] = `<div class='jqvmap-circle'>${ val.provinsi }</div>`;
                    });

                    // Mapping Data
                    jQuery('#vmap').vectorMap({
                        map: 'indonesia_id',
                        backgroundColor: '#f2fbff',
                        color: '#dae183',
                        hoverColor: '#00b775',
                        enableZoom: false,
                        showTooltip: true,
                        selectedColor: null,
                        selectedRegions: false,
                        normalizeFunction: 'linear',
                        pins: this.tagged,
                        onLabelShow: (event, label, code) => {
                            var regionName = label[0].innerHTML;
                            var html = [`
                                <table>
                                    <tr>
                                        <td colspan="2" class="text-center">${ regionName }</td>
                                    </tr>
                                    <tr>
                                        <td>Pedagogic</td>
                                        <td>${ this.data[code].kompetensipedagogic }</td>
                                    </tr>
                                    <tr>
                                        <td>Kepribadian</td>
                                        <td>${ this.data[code].kompetensikepribadian }</td>
                                    </tr>
                                    <tr>
                                        <td>Sosial</td>
                                        <td>${ this.data[code].kompetensisosial }</td>
                                    </tr>
                                    <tr>
                                        <td>Profesional</td>
                                        <td>${ this.data[code].kompetensiprofesional }</td>
                                    </tr>
                                    <tr>
                                        <td>Methodology</td>
                                        <td>${ this.data[code].kompetensimethodology }</td>
                                    </tr>
                                    <tr>
                                        <td>IT</td>
                                        <td>${ this.data[code].kompetensiit }</td>
                                    </tr>
                                    <tr>
                                        <td>Impact and Influence</td>
                                        <td>${ this.data[code].kompetensiimpactandinfluence }</td>
                                    </tr>
                                    <tr>
                                        <td>Achievement Orientation</td>
                                        <td>${ this.data[code].kompetensiachievementorientation }</td>
                                    </tr>
                                    <tr>
                                        <td>Nasionalism</td>
                                        <td>${ this.data[code].kompetensinasionalism }</td>
                                    </tr>
                                    <tr>
                                        <td>Developing Others</td>
                                        <td>${ this.data[code].kompetensidevelopingothers }</td>
                                    </tr>
                                </table>
                            `
                            ].join("");
                            label[0].innerHTML = html;
                        }
                    });
                })
                .catch( (error) => {
                    console.log(error);
                });
        }
    }
}
</script>
